IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'STATUS_LOTECTB_NOTAFISCAL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER STATUS_LOTECTB_NOTAFISCAL
GO

CREATE TRIGGER STATUS_LOTECTB_NOTAFISCAL ON NOTAFISCAL
FOR DELETE,UPDATE
AS
DECLARE @V_CDLOTE           VARCHAR(20);
DECLARE @V_NRLANCLOTE       VARCHAR(06);
DECLARE @V_DTINICCTBL       DATETIME;
DECLARE @V_DTFINACCTBL      DATETIME;
DECLARE @OLD_CDEMPRESA      VARCHAR(2);
DECLARE @OLD_IDSTATUS       VARCHAR(1);
DECLARE @NEW_IDSTATUS       VARCHAR(1);
DECLARE @OLD_IDENTRSAIDOP   VARCHAR(1);
DECLARE @OLD_IDSISTEMA      VARCHAR(5);
DECLARE @OLD_DTENTRSAID     DATETIME;
DECLARE @OLD_CDFILIAL       VARCHAR(4);
DECLARE @OLD_NRLANCTONF     VARCHAR(10);
DECLARE @V_IDTPGERACAOCONT  VARCHAR(1);
DECLARE @V_INSERTED         INT;
DECLARE @V_DELETED          INT;
                                                                                                          
BEGIN
   SELECT @V_IDTPGERACAOCONT = IDTPGERACAOCONT FROM PARAMCTBL;

   IF @V_IDTPGERACAOCONT <> 'O' BEGIN

      DECLARE C_NOTAFISCAL CURSOR FOR
       SELECT CDEMPRESA, IDSTATUS, IDENTRSAIDOP, DTENTRSAID, CDFILIAL, NRLANCTONF, DTENTRSAID, IDSISTEMA
         FROM DELETED;

      OPEN C_NOTAFISCAL;

      FETCH NEXT FROM C_NOTAFISCAL INTO @OLD_CDEMPRESA, @OLD_IDSTATUS, @OLD_IDENTRSAIDOP, @OLD_DTENTRSAID,
                                        @OLD_CDFILIAL, @OLD_NRLANCTONF, @OLD_DTENTRSAID, @OLD_IDSISTEMA;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @OLD_IDSISTEMA IN ('PAG','REC') BEGIN
            SELECT @V_DTINICCTBL = DTINICCTBL,  @V_DTFINACCTBL = DTFINACCTBL
              FROM CONTOPECTBL
             WHERE CDEMPRESA = @OLD_CDEMPRESA;
         END
         ELSE BEGIN
            IF @OLD_IDENTRSAIDOP = 'E' BEGIN
               SELECT @V_DTINICCTBL = DTINIINTCONTDFE,  @V_DTFINACCTBL = DTFININTCONTDFE
                 FROM CONTOPECTBL
                WHERE CDEMPRESA = @OLD_CDEMPRESA;
            END
            ELSE BEGIN
               SELECT @V_DTINICCTBL = DTINIINTCONTDFS,  @V_DTFINACCTBL = DTFININTCONTDFS
                 FROM CONTOPECTBL
                WHERE CDEMPRESA = @OLD_CDEMPRESA;
            END;
         END;

         SELECT @V_INSERTED = COUNT(*) FROM INSERTED;

         SELECT @V_DELETED = COUNT(*) FROM DELETED;

         DECLARE C_IDSTATUS CURSOR FOR
            SELECT IDSTATUS
              FROM INSERTED;
         OPEN C_IDSTATUS;

         FETCH NEXT FROM C_IDSTATUS INTO @NEW_IDSTATUS;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (((@V_DELETED <> 0) AND (@V_INSERTED = 0)) OR ((@V_INSERTED = 1) AND (@V_DELETED = 1) AND (@OLD_IDSTATUS IN ('A', 'E') AND @NEW_IDSTATUS IN ('P', 'V')))) BEGIN
               IF @OLD_DTENTRSAID >= @V_DTINICCTBL AND @OLD_DTENTRSAID <= @V_DTFINACCTBL BEGIN
                  DECLARE C_RELACNFLANCLOTE CURSOR FOR
                     SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                       FROM RELACNFLANCLOTE
                      WHERE CDEMPRESA  = @OLD_CDEMPRESA
                        AND CDFILIAL   = @OLD_CDFILIAL
                        AND NRLANCTONF = @OLD_NRLANCTONF;
                  OPEN C_RELACNFLANCLOTE;

                  FETCH NEXT FROM C_RELACNFLANCLOTE INTO @V_CDLOTE, @V_NRLANCLOTE;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                    EXEC REVERTE_LOTE @OLD_CDEMPRESA, @V_CDLOTE;

                    DELETE FROM RELACNFLANCLOTE
                     WHERE CDEMPRESA  = @OLD_CDEMPRESA
                       AND CDLOTE     = @V_CDLOTE
                       AND NRLANCLOTE = @V_NRLANCLOTE
                       AND CDFILIAL   = @OLD_CDFILIAL
                       AND NRLANCTONF = @OLD_NRLANCTONF;

                    DELETE FROM LANCLOTE
                     WHERE CDEMPRESA  = @OLD_CDEMPRESA
                       AND CDLOTE     = @V_CDLOTE
                       AND NRLANCLOTE = @V_NRLANCLOTE;

                    IF (@V_DELETED = 1) AND (@V_INSERTED = 1) BEGIN
                      UPDATE NOTAFISCAL
                         SET IDSTATUSCTBNF = 'P'
                        FROM INSERTED, DELETED
                       WHERE (ISNULL(INSERTED.CDFILIAL,  0) <> ISNULL(DELETED.CDFILIAL,  0))
                         AND (ISNULL(INSERTED.NRLANCTONF,0) <> ISNULL(DELETED.NRLANCTONF,0));
                    END;

                    FETCH NEXT FROM C_RELACNFLANCLOTE INTO @V_CDLOTE, @V_NRLANCLOTE;
                  END;
                  CLOSE C_RELACNFLANCLOTE;
                  DEALLOCATE C_RELACNFLANCLOTE;
               END
               ELSE BEGIN
                  RAISERROR('Excluso no permitida, lanamento fora do perodo contbil.', 16, 1);
               END;
            END;
           FETCH NEXT FROM C_IDSTATUS INTO @NEW_IDSTATUS;
         END;
         CLOSE C_IDSTATUS;
         DEALLOCATE C_IDSTATUS;

      FETCH NEXT FROM C_NOTAFISCAL INTO @OLD_CDEMPRESA, @OLD_IDSTATUS, @OLD_IDENTRSAIDOP, @OLD_DTENTRSAID,
                                          @OLD_CDFILIAL, @OLD_NRLANCTONF, @OLD_DTENTRSAID, @OLD_IDSISTEMA;
      END;
      CLOSE C_NOTAFISCAL;
      DEALLOCATE C_NOTAFISCAL;
   END;
END;
GO
